/** 
 *   FIXME ....
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#include <stdio.h>
#include <unistd.h>

#include "socket_client.h"
#include "iar_bus.h"


int impares(void)
{
	int fd;
	int ret = 1;
	int data;
	struct ib_data d;

	//fd = call_socket("127.0.0.1", 2021);
	fd = call_socket_local("test");
	ibus_send( fd, IB_BUS_ADDR, IB_CM_ON, 0, 0);

	while(ret > 0){
		ret = read(fd, &d, sizeof(struct ib_data_head) );
		if( d.h.size > 0) {
			ret = read(fd, &data, sizeof(int) );
			if( data & 0x1 ){
				data++;
				//printf("Imp. send: %d\n",data);
				ibus_send( fd, IB_BROADCAST_ADDR, 
					   IB_CM_MESSAGE,
					   &data, sizeof(int));
			}				
		}
	}

	return 0;
}


int pares(void)
{
	int fd;
	int ret = 1;
	int data;
	struct ib_data d;

	//fd = call_socket("127.0.0.1", 2021);
	fd = call_socket_local("test");

	ibus_send( fd, IB_BUS_ADDR, IB_CM_ON, 0, 0);

	while(ret > 0){
		ret = read(fd, &d, sizeof(struct ib_data_head) );
		if( d.h.size > 0) {
			ret = read(fd, &data, sizeof(int) );
			if( !(data & 0x1) ){
				data++;
				//sleep(1);
				//printf("Par  send: %d\n",data);
				ibus_send( fd, IB_BROADCAST_ADDR, 
					   IB_CM_MESSAGE,
					   &data, sizeof(int));
			}				
		}
	}

	return 0;
}



int main(int argc, const char *argv[]) 
{
	int pid;
	struct ib_command cm[] = {
		{IB_CM_MESSAGE, ib_cm_message},
		{IB_CM_REMOVE, ib_cm_remove},
		{IB_CM_ON,     ib_cm_on},
		{IB_CM_OFF,    ib_cm_off},
		//{"w", ib_cm_who},
		{IB_CM_MESSAGE_TO, ib_cm_message_to},
		//{"wa", ib_cm_whoami},
		//{"sid", ib_cm_set_id},
		{0, NULL}
	};

	if ( (pid=fork()) == 0 ) {
		//init_iar_bus_inet(cm, 2021);
		init_iar_bus_local(cm, "test");
	}
	sleep(1);
	if ( (pid=fork()) == 0 ) {
		pares();
	}
	impares();

	return 0;
}

